class JobsController < ApplicationController
  before_action :set_job, only: %i[show edit update destroy cancel]

  # GET /jobs or /jobs.json
  def index
    @jobs = Job.currently_working_on
  end

  # GET /jobs/1 or /jobs/1.json
  def show; end

  # GET /jobs/new
  def new
    @job = Job.new
  end

  # GET /jobs/1/edit
  def edit; end

  # POST /jobs or /jobs.json
  def create
    @job = Job.new(job_params)

    respond_to do |format|
      if @job.save
        flash[:notice] = 'Job was successfully created.'
        Turbo::StreamsChannel.broadcast_prepend_later_to 'jobs', target: :jobs, partial: 'jobs/job_tr',
                                                                 locals: { job: @job }
        format.html { redirect_to jobs_url }
        format.json { render :show, status: :created, location: @job }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @job.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /jobs/1 or /jobs/1.json
  def update
    respond_to do |format|
      if @job.update(job_params)
        broadcast_update_job
        format.html { redirect_to jobs_url, notice: 'Job was successfully updated.' }
        format.json { render :show, status: :ok, location: @job }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @job.errors, status: :unprocessable_entity }
      end
    end
  end
  
  # DELETE /jobs/1 or /jobs/1.json
  def destroy
    @job.destroy!
    
    respond_to do |format|
      Turbo::StreamsChannel.broadcast_remove_to 'jobs', target: @job
      format.html { redirect_to jobs_url, notice: 'Job was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def cancel
    if @job.canceled!
      flash[:notice] = 'Job successfully canceled'
    else
      flash[:alert] = 'Job could not be canceled'
    end
    
    respond_to do |format|
      broadcast_update_job
      format.turbo_stream
      format.html { redirect_to jobs_url }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_job
    @job = Job.find(params[:id])
  end

  def broadcast_update_job
    Turbo::StreamsChannel.broadcast_replace_later_to 'jobs', target: @job, partial: 'jobs/job_tr', locals: { job: @job }
  end

  # Only allow a list of trusted parameters through.
  def job_params
    params.require(:job).permit(:operator_id, :costumer_id, :operator_firstname, :operator_lastname,
                                :costumer_firstname, :costumer_lastname, :paid, :printed_at, :intern,
                                :cost_center, :number_of_plans_a0, :number_of_plans_a1,
                                :number_of_plans_a2, :number_of_plans_a3, :costum_qm_plan, :privacy_policy_accepted, :pdf)
  end
end
